package com.junmp.print.dao.entity;

import com.junmp.print.dao.service.CommonService;
import com.junmp.print.util.TimeUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/1
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class ProductEpc144{

    CommonService commonService = new CommonService();


    //标签epc长度
    private int iTagLength = 36;

    //EPC中标签类型 1位十进制 0-F 0-单品物资标签，1-箱标签，2-托盘标签，3-货架标签，4-批物资标签
    private String strTagType = "";


    //EPC中对应企业代码 6位十进制 000000-FFFFFF
    private String strSCCSNo = "";

    //数据库中生产企业代码
    private String strSccsCode;

    //生产企业名称
    private String strSCCSName = "";

    //EPC中物资代码,LSM
    private String strWzLsm = "0";

    //数据库中物资代码 LSM
    private Integer iWzLsm;

    //EPC中物资代码, 7位十六进制 000000000-FFFFFFFFF
    //private String  strWzNo = "FF000FF";

    //数据库中物资代码 52m码
    private Long iWzNo;

    //数据库中物资代码 对应的NID
    //private Long iWzID;

    //物资名称
    private String strWzName ="";

    //号型名称
    private String strWzHXName = "";

    //epc中包装类型 1位十六进制 0-F 1-外包装，2-中安装，3-内包装，F-零头配箱
    private String strBzType = "";

    //Epc 中生产日期 6位十六进制 YYMMDD
    private String strScrq = "120101";

    //数据库 中生产日期
    private Integer dtScrq;

    //Epc中下级包装数量
    private String strXjbzsl = "0";

    //数据库中下级包装数量
    private Integer iXjbzsl;

    //EPC中产品总数量
    private String strNum = "0";

    //数据库中产品总数量
    private Integer iNum;

    //epc中箱序号 4位 生产线序号+包装箱序号
    private String strXSerialno = "0";

    //数据库中箱序号
    //private Integer iXSerialno;

    //epc 中企业生产线序号 1位十六进制 0-F 十六进制 0-E表示生产线序列号，F表示军需仓库打印的标签
    private String strScxNo = "0";

    //数据库中十进制企业生产线序号
    private Integer iScxNo;

    //epc 中包装箱序号
    private String strXiangNo = "0";

    //数据库中 十进制包装箱序号
    private Integer iXangNo;

    //epc中箱内序号 4位 0000-FFFF
    private String strXnSerialno = "00";

    //数据库中箱内序号
    //private Integer iXnSerialno;

    //epc中校验码 1位十六进制
    private String strJiaoYan = "0";

    //epc
    private String strEpc = "";

    //起始箱号
    private Integer iStartXNo = 0;

    //当前编码版本
    private String strCopyright = "0";

    //该epc相同的共有几个
    private Integer iBqAll;

    //该epc相同的共有几个
    private String strBqAll = "0";

    //该epc相同的共有几个
    private Integer iBqNo;

    //该epc相同的共有几个
    private String strBqNo = "1";

    public String getStrCopyright() {
        return strCopyright;
    }

    public void setStrCopyright(String strCopyright) {
        this.strCopyright = strCopyright;
    }

    public Integer getiBqAll() {
        return Integer.parseInt(strBqAll,16);
    }

    public void setiBqAll(Integer iBqAll) {
        this.strBqAll = Integer.toHexString(iBqAll);
    }

    public String getStrBqAll() {
        return strBqAll;
    }

    public void setStrBqAll(String strBqAll) {
        this.strBqAll = strBqAll;
    }

    public Integer getiBqNo() {
        return Integer.parseInt(strBqNo,16);
    }

    public void setiBqNo(Integer iBqNo) {
        this.strBqNo = Integer.toHexString(iBqNo);
    }

    public String getStrBqNo() {
        return strBqNo;
    }

    public void setStrBqNo(String strBqNo) {
        this.strBqNo = strBqNo;
    }

    public int getiTagLength() {
        return iTagLength;
    }

    public void setiTagLength(int iTagLength) {
        this.iTagLength = iTagLength;
    }

    public String getStrTagType() {
        return strTagType;
    }

    public void setStrTagType(String strTagType) {
        this.strTagType = strTagType;
    }

    public String getStrSCCSNo() {
        return strSCCSNo;
    }

    public void setStrSCCSNo(String strSCCSNo) {
        this.strSCCSNo = strSCCSNo;
    }

    public String getStrSccsCode() {
        StringBuffer strb = new StringBuffer(String.valueOf(Integer.parseInt(strSCCSNo,16)));
        return "D" + strb.delete(0,1).toString();
    }

    public void setStrSccsCode(String strSccsCode) {
        StringBuffer strb = new StringBuffer(strSccsCode);
        String str = "1" + strb.delete(0,1).toString();
        this.strSCCSNo = String.format("%06d", Integer.parseInt(str,16));
    }

    public String getStrSCCSName() {
        return strSCCSName;
    }

    public void setStrSCCSName(String strSCCSName) {
        this.strSCCSName = strSCCSName;
    }

    public String getStrWzLsm() {
        return strWzLsm;
    }

    public void setStrWzLsm(String strWzLsm) {
        this.strWzLsm = strWzLsm;
    }

    public Integer getiWzLsm() {
        //return iWzLsm;
        return Integer.parseInt(strWzLsm,16);
    }

    public void setiWzLsm(Integer iWzLsm) {
        //this.iWzLsm = iWzLsm;
        this.strWzLsm = Integer.toHexString(iWzLsm);
    }

    public Long getiWzNo() {
        return iWzNo;
    }

    public void setiWzNo(Long iWzNo) {
        this.iWzNo = iWzNo;
    }

    public String getStrWzName() {
        return strWzName;
    }

    public void setStrWzName(String strWzName) {
        this.strWzName = strWzName;
    }

    public String getStrWzHXName() {
        return strWzHXName;
    }

    public void setStrWzHXName(String strWzHXName) {
        this.strWzHXName = strWzHXName;
    }

    public String getStrBzType() {
        return strBzType;
    }

    public void setStrBzType(String strBzType) {
        this.strBzType = strBzType;
    }

    public String getStrScrq() {
        return strScrq;
    }

    public void setStrScrq(String strScrq) {
        this.strScrq = strScrq;
    }

    public Integer getDtScrq() {
        //return dtScrq;
        try{
            String year = "20" + strScrq.substring(0,2);
            String month =  strScrq.substring(2,4);
            String day = strScrq.substring(4,6);
            return TimeUtil.getDateInt(year+"-"+month+"-"+day+" 00:00:00");
        }catch(Exception e){
            return TimeUtil.getDateInt(TimeUtil.getDate());
        }
    }

    public void setDtScrq(Integer dtScrq) {
        //this.dtScrq = dtScrq;
        this.strScrq = TimeUtil.getDateStringShortSix(dtScrq);
    }

    public String getStrXjbzsl() {
        return strXjbzsl;
    }

    public void setStrXjbzsl(String strXjbzsl) {
        this.strXjbzsl = strXjbzsl;
    }

    public Integer getiXjbzsl() {
        //return iXjbzsl;
        return Integer.parseInt(strXjbzsl,16);
    }

    public void setiXjbzsl(Integer iXjbzsl) {
        //this.iXjbzsl = iXjbzsl;
        this.strXjbzsl = Integer.toHexString(iXjbzsl);
    }

    public String getStrNum() {
        return strNum;
    }

    public void setStrNum(String strNum) {
        this.strNum = strNum;
    }

    public Integer getiNum() {
        return Integer.parseInt(strNum,16);
    }

    public void setiNum(Integer iNum) {
        //this.iNum = iNum;
        this.strNum = Integer.toHexString(iNum);
    }

    public String getStrXSerialno() {
        //return strXSerialno;
        return String.valueOf(this.iScxNo) + "/" + String.valueOf(this.iXangNo);
    }

    public void setStrXSerialno(String strXSerialno) {
        this.strXSerialno = strXSerialno;
        this.strScxNo = strXSerialno.substring(0,1);
        this.strXiangNo = strXSerialno.substring(1);
    }

    public String getStrScxNo() {
        return strScxNo;
    }

    public void setStrScxNo(String strScxNo) {
        this.strScxNo = strScxNo;
    }

    public Integer getiScxNo() {
        //return iScxNo;
        return Integer.parseInt(strScxNo,16);
    }

    public void setiScxNo(Integer iScxNo) {
        //this.iScxNo = iScxNo;
        this.strScxNo = Integer.toHexString(iScxNo);
    }

    public String getStrXiangNo() {
        return strXiangNo;
    }

    public void setStrXiangNo(String strXiangNo) {
        this.strXiangNo = strXiangNo;
    }

    public Integer getiXangNo() {
        //return iXangNo;
        return Integer.parseInt(strXiangNo,16);
    }

    public void setiXangNo(Integer iXangNo) {
        //this.iXangNo = iXangNo;
        this.strXiangNo = Integer.toHexString(iXangNo);
    }

    public String getStrXnSerialno() {
        return strXnSerialno;
    }

    public void setStrXnSerialno(String strXnSerialno) {
        this.strXnSerialno = strXnSerialno;
    }

    public String getStrJiaoYan() {
        return strJiaoYan;
    }

    public void setStrJiaoYan(String strJiaoYan) {
        this.strJiaoYan = strJiaoYan;
    }

    public String getStrEpc() {
        return strEpc;
    }

    public void setStrEpc(String strEpc) {
        this.strEpc = strEpc;
    }

    public Integer getiStartXNo() {
        return iStartXNo;
    }

    public void setiStartXNo(Integer iStartXNo) {
        this.iStartXNo = iStartXNo;
    }

    public int getStartXiangNo(){
        return 1;
    }
    public String creatEpc(){
        strEpc = strTagType;
        strEpc += strSCCSNo;
        strEpc += strWzLsm;
        strEpc += strBzType;
        strEpc += strScrq;
        strEpc += strXjbzsl;
        strEpc += strNum;
        strEpc += strScxNo + strXiangNo;
        strEpc += strXnSerialno;
        strEpc += strJiaoYan;

        return strEpc;
    }
    public void getInfoFromEpc(){
        switch (iTagLength){
            case 32:
                try{
                    String tagType = strEpc.substring(0,1);
                    if(tagType.equals("1")){
                        this.strTagType = strEpc.substring(0,1);
                        this.strSCCSNo = strEpc.substring(1,7) ;
                        this.strBzType = strEpc.substring(7,8) ;
                        this.strWzLsm = strEpc.substring(8,16) ;
                        this.strScrq = strEpc.substring(16,22) ;
                        this.strXjbzsl = strEpc.substring(22,24) ;
                        this.strNum = strEpc.substring(24,27) ;
                        this.strScxNo = strEpc.substring(27,28) ;
                        this.strXiangNo = strEpc.substring(28,31) ;
                        this.strJiaoYan = strEpc.substring(31,32) ;
                        this.strBqNo = strEpc.substring(32,33) ;
                        this.strBqAll = strEpc.substring(33,34) ;
                        this.strCopyright = strEpc.substring(34,35) ;

                    }else if(tagType.equals("2")){
                        this.strTagType = strEpc.substring(0,1);
                    }

                }catch(Exception e){

                }
        }

    }
    public void getSCCSInfo(){
        try{
            List<TabBzglWzdmBean> listBeans = commonService.getSCCSInfo(this.strSccsCode);
            if(listBeans.size()>0){
                this.strSCCSName = listBeans.get(0).getStrcsmc();
            }
        }catch (Exception e){

        }

    }
    public void getWZHXInfo(){
        try{
            List<TabBzglWzdmBean> listBeans = commonService.getWZHXInfo(String.valueOf(this.iWzLsm));
            if(listBeans.size()>0){
                this.iWzNo = Long.getLong(listBeans.get(0).getStrwzdm());
                this.strWzName = listBeans.get(0).getStrwzmc();
                this.strWzHXName = listBeans.get(0).getStrwzhx();
            }
        }catch (Exception e){

        }
    }
}
