package com.junmp.print.ui.matcheck.plan;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.text.Layout;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.presenter.BaseActivityPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.matcheck.out.outcount.OutCountActivity;
import com.junmp.print.ui.matcheck.plan.importplan.TfImportActivity;
import com.junmp.print.ui.matcheck.plan.maintain.TfMaintainActivity;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：运输计划管理菜单页面
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfMaintainMenuActivity extends BaseActivity {

    @BindView(R.id.tv_matCheck_transferplan_import)
    LinearLayout importTv;

    @BindView(R.id.tv_matCheck_transferplan_maintain)
    LinearLayout maintainTv;

    @Override
    protected BaseActivityPresenter createPresenter() {
        return null;
    }

    @Override
    protected int getLayoutContentViewId() {
        return  R.layout.activity_check_transferplan_menu;
    }

    @Override
    public void initView() {

    }

    @OnClick({R.id.tv_matCheck_transferplan_import,R.id.tv_matCheck_transferplan_maintain})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.tv_matCheck_transferplan_import:
                //跳转“运输计划导入”
                jumpToActivity(TfImportActivity.class);
                break;
            case R.id.tv_matCheck_transferplan_maintain:
               //跳转“运输计划维护页面”
                jumpToActivity(TfMaintainActivity.class);
                break;
        }

    }
}
