package com.junmp.print.view;
import android.content.Context;
import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.widget.ListView;
import android.widget.ScrollView;
/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2019/4/2
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class MyListView  extends ListView {
    private ScrollView scrollView;
    private boolean notAllowParentScroll = true;

    public void setNotAllowParentScroll(boolean notAllowParentScroll) {
        this.notAllowParentScroll = notAllowParentScroll;
    }

    public void setScrollView(ScrollView scrollView) {
        this.scrollView = scrollView;
    }

    public MyListView(Context context) {
        super(context);
    }

    public MyListView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    @Override
    public boolean dispatchTouchEvent(MotionEvent event) {
        if(notAllowParentScroll){
            switch(event.getAction()){
                case MotionEvent.ACTION_DOWN:
                    scrollView.requestDisallowInterceptTouchEvent(true);//如果为true的话滑动不流畅，等滑两次才开始改变位置
                    break;
                case MotionEvent.ACTION_UP:
                    scrollView.requestDisallowInterceptTouchEvent(false);//同样为true滑动不流畅，得滑动两次才改变位置
                    break;
            }
        }
        return super.dispatchTouchEvent(event);
    }

}