package com.junmp.print.dao.service;

import com.google.common.collect.Lists;
import com.junmp.print.PrintApplication;
import com.junmp.print.dao.db.JpTabConfigDao;
import com.junmp.print.dao.entity.JpTabConfig;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/24
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class JpTabConfigService {

    /**
     * 查询
     */
    public List getConfig() {
        List<JpTabConfig> listBeans = Lists.newArrayList();
        listBeans = PrintApplication.getDaoSession().getJpTabConfigDao()
                .loadAll();
        return listBeans;
    }

    /**
     * 查询
     */
    public JpTabConfig getConfigByid(Long id) {
        List<JpTabConfig> listBeans = Lists.newArrayList();
        listBeans = PrintApplication.getDaoSession().getJpTabConfigDao().queryBuilder()
                .where(JpTabConfigDao.Properties.Id.eq(id)).list();
        return listBeans.get(0);
    }

    /**
     * 完成对某一数据的修改
     */
    public boolean update(JpTabConfig jpTabConfig){
        boolean flag = false;

        try{
            PrintApplication.getDaoSession().getJpTabConfigDao().update(jpTabConfig);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

}
