package com.junmp.print.presenter;

import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.dao.service.JpTabWzjyService;
import com.junmp.print.iview.IRandomCheckListView;
import com.junmp.print.ui.BaseActivity;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：随机校验查询列表
 * 版本：1.0
 * 日期：2018/5/28
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RandomCheckListPresenter extends BaseActivityPresenter<IRandomCheckListView> {

    public RandomCheckListPresenter(BaseActivity context) {
        super(context);
    }

    protected JpTabWzjyService jpTabWzjyService = new JpTabWzjyService();



    public void getWzJyTjMx(String wzmc,String wzhx){
        try{
            List<JpTabWzjyBean> listBeans = new ArrayList<>();
            listBeans = jpTabWzjyService.getWzJyTjMx(wzmc,wzhx);
            getView().showWzJyTjMx(listBeans,wzmc,wzhx);
        }catch (Exception e){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }
}


